// Generated by CoffeeScript 1.4.0
var addLayoutSubmitData, casper;

casper = require('casper').create({
  pageSettings: {
    loadImages: false,
    loadPlugins: false
  }
});

casper.start("http://localhost:3333/sections/membership/#/1", function() {
  this.capture('sections.membership.screenList.png');
  return this.test.comment('ScreenList');
});

casper.then(function() {
  this.test.assertExists('ul.thumbnails', 'the list must be present by thumbnails');
  this.test.assertSelectorHasText('.btn.btn-primary', 'Добавить эскиз', 'add layout button must be present');
  return this.test.assertExists('.thumbnail .btn.btn-danger i.icon-remove', 'every layout can be deleted by user');
});

casper.then(function() {
  try {
    return this.click('.btn.btn-primary i.icon-plus');
  } catch (e) {
    return this.test.fail('failed to click on Add Layout button, may be it is not exists?');
  }
});

addLayoutSubmitData = {
  layout: 'sample.png',
  description: 'Some description'
};

casper.waitForSelector('#addLayout', function() {
  this.capture('sections.membership.addLayout.png');
  this.test.comment('AddLayout');
  this.test.assertExists('.btn.btn-primary i.icon-ok', 'save button must be present');
  this.test.assertExists('.btn i.icon-ban-circle', 'cancel button must be preset');
  this.test.assertExists('form#addLayout-form textarea[name=description]', 'description field must be present');
  this.test.assertExists('form#addLayout-form input[type=file, name=layout]', 'Layout upload field must be present');
  this.fill('form#addLayout-form', addLayoutSubmitData, true);
  return this.test.done();
}, function() {
  return this.test.fail('failed to load Add Layout page, may be it is not exists?');
}, 1000);

casper.then(function() {
  this.test.assertTextExists(addLayoutSubmitData.description, 'Added layout must be present after form submit');
  return this.test.assertSelectorHasText('div.thumbnail p', addLayoutSubmitData.description, 'Added layout must have correct description');
});

casper.thenEvaluate(function(data) {
  var $correctProject;
  $correctProject = $('div.thumbnail p').filter(function() {
    return this.text() === data.description;
  });
  return $correctProject.first().parent().find(".btn.btn-danger").click();
}, addLayoutSubmitData);

casper.then(function() {
  this.test.assertSelectorDoesntHaveText('div.thumbnail p', addLayoutSubmitData.description, 'Added test layout must be removed after click on delete button');
  return this.test.done();
});

casper.run();
